<template>
    <div class="study-item" v-if="data" style="cursor:pointer" :style="{'background-color': getIconColor(data.study_specimen)}">
        <div class="top-row">
            <div class="icons">
                <Icon icon="material-symbols-light:lock" color="#000" width="30" v-if="data.study_visibility == 'private'"/>
                <Icon icon="material-symbols-light:lock-open-right" color="#000" width="30" height="30" v-if="data.study_visibility == 'public'"/>

                <span v-if="data.study_specimen" class="study-type">{{ data.study_specimen.toUpperCase() }}</span>

                <span v-if="data.study_type" class="study-type">{{ data.study_type }}</span>
            </div>
            <span>{{Object.keys(data.study_members as object).filter((user) => data?.study_members[user as keyof object] == "uploader").toString() }}</span>
        </div>
        <div class="study-title">
            <span style="font-size: var(--fs-large)"> {{ data.study_name }} </span><br>
            <span style="font-size: var(--fs-smaller);">{{ data.study_author.split(",")[0] }}<span v-if="data.study_author.split(',').length > 1"> et al.</span></span>
        </div>
        <!--<div class="bottom-row">
            <div v-if="data.study_members">{{ Object.keys(data.study_members).length }} contributor(s)</div>
            <div v-if="data.study_compounds">{{ Object.keys(data.study_compounds).length }} compound(s)</div>
        </div>-->
    </div>
</template>

<script setup lang="ts">
import { type StudyData } from "@/stores/studies";
import { Icon } from '@iconify/vue';
import type { PropType } from "vue";

const props = defineProps({
    data: Object as PropType<StudyData>,
    status: String,
})

const getIconColor = (specimen: string) => {
    switch (specimen) {
        case 'blood':
        case 'plasma':
        case 'serum':
            return 'var(--color-blood)';
        case 'urine':
            return 'var(--color-urine)';
        case 'feces':
            return 'var(--color-feces)';
        case 'csf':
            return 'var(--color-csf)';
        case 'multiple':
            return 'var(--color-multiple)';
        case 'other':
            return 'var(--color-other)';
        default:
            return 'var(--color-unknown)';
    }
}

</script>

<style scoped>
    .study-item {
        width: 20rem;
        height: 10rem;
        box-shadow: var(--sd-default);
        display: grid;
        grid-auto-flow: column;
        grid-template-rows: 1fr 8fr 1fr;
        font-size: var(--fs-small);
        backdrop-filter: blur(0.5px);
    }

    .top-row {
        margin: 0 4px;
        display: flex;
        align-items: center;
        justify-content: space-between;
        font-family: 'Roboto Mono', monospace;
    }

    .icons {
        display: flex;
        justify-items: baseline;
        align-items: center;
        gap: 4px;
    }


    .study-type {
        font-family: 'Roboto Mono', monospace;
        font-size: 0.75rem;
        margin-left: 0.15rem;
        color: var(--color-text);
    }

    .study-title {
        display: flex;
        align-items: center;
        justify-content: center;
        text-align: center;
        flex-direction: column;
        line-height: 1.125rem;
    }

    .bottom-row {
        font-family: 'Roboto Mono', monospace;
        margin: 0 4px;
        display: flex;
        justify-content: space-between;
        font-size: 0.65rem;
    }

</style>